import es, gamethread, playerlib, os.path, random

info = es.AddonInfo() 
info['name']        = "Anti Camp and Anti AFK" 
info['version']     = "1.0.0" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/afkcamp" 
info['description'] = "An anti camp manager, and anti afk manager to get rid of two annoying player types!" 

es.ServerVar('ac_version', info['version'], 'Anti Camp and Anti AFK made by Bonbon AKA Bonbon367').makepublic()


sv_options = {
	'ac_camping_bots': 1,
	'ac_camper_push': 275,
	'ac_camp_range': 60,
	'ac_camp_damage': 5,
	'ac_camp_time': 20,
	'ac_in_spawn_speedup': 2,
	'ac_afks_affected_by_anticamp': 1,
	'ac_afk_kick_time': 5,
	'ac_afk_rounds_kick': 3,
	'ac_rounds_move_to_spec': 2,
	'ac_immune_campers': 'STEAM_0:0:1231232,STEAM_0:1231232',
	'ac_immune_afk': 'STEAM_0:0:1231232,STEAM_0:1231232',
	'ac_gg_spawn_camp_boost': 0,
	'ac_gg_spawn_point_range': 300,
	'ac_excluded_camp_weapons': 0,
}
afk_data = {}
afk_time = {}
coords = {}
sv = es.ServerVar

def load():
	for option in sv_options:
		es.ServerVar(option).set(sv_options[option])
	if os.path.isfile(es.getAddonPath('anticamp') + '/anticamp.cfg'):
		es.server.cmd('es_xmexec ../addons/eventscripts/anticamp/anticamp.cfg')
	for userid in es.getUseridList():
		stop_camp(userid)
		unmakeafk(userid)
	afk_check_changed()
	gamethread.delayed(0, camp_loop)

def unload():
	for delay in ['camp_loop', 'afk_loop']:
		gamethread.cancelDelayed(delay)

def player_disconnect(ev):
	if int(ev['userid']) in coords:
		del coords[int(ev['userid'])]
	if int(ev['userid']) in afk_time:
		del afk_time[int(ev['userid'])]
	if int(ev['userid']) in afk_data:
		del afk_data[int(ev['userid'])]

def player_activate(ev):
	stop_camp(ev['userid'])

def player_spawn(ev):
	stop_camp(ev['userid'])
	p = playerlib.getPlayer(ev['userid'])
	afk_data[int(ev['userid'])] = {'vector': p.get('viewvector'), 'prim': p.get('primary'), 'sec': p.get('secondary'), 'loc': p.get('location'), 'he': p.get('he'), 'sg': p.get('sg'), 'fb': p.get('fb')}

def round_freeze_end(ev):
	for userid in es.getUseridList():
		stop_camp(userid)

def player_hurt(ev):
	unmakeafk(int(ev['attacker']))
	userid = int(ev['userid'])
	p = playerlib.getPlayer(userid)
	afk_data[int(userid)] = {'vector': p.get('viewvector'), 'prim': p.get('primary'), 'sec': p.get('secondary'), 'loc': p.get('location'), 'he': p.get('he'), 'sg': p.get('sg'), 'fb': p.get('fb')}

def player_say(ev):
	unmakeafk(int(ev['userid']))

def player_changename(ev):
	unmakeafk(int(ev['userid']))

def player_jump(ev):
	unmakeafk(int(ev['userid']))

def bomb_begindefuse(ev):
	unmakeafk(int(ev['userid']))

def bomb_beginplant(ev):
	unmakeafk(int(ev['userid']))

def player_zoom(ev):
	unmakeafk(int(ev['userid']))

def player_team(ev):
	userid = int(ev['userid'])
	if es.exists('userid', userid):
		p = playerlib.getPlayer(userid)
		afk_data[userid] = {'vector': p.get('viewvector'), 'prim': p.get('primary'), 'sec': p.get('secondary'), 'loc': p.get('location'), 'he': p.get('he'), 'sg': p.get('sg'), 'fb': p.get('fb')}

def round_end(ev):
	for userid in es.getUseridList():
		if userid in afk_time:
			if afk_time[userid]['time'] >= 30:
				afk_time[userid]['rounds'] += 1
				if int(sv('ac_rounds_move_to_spec')) and afk_time[userid]['rounds'] >= int(sv('ac_rounds_move_to_spec')):
					es.changeteam(userid, 1)
					es.tell(userid, '#multi', '#lightgreen[Anti Camp]: #defaultYou have been moved to spectator for being afk!')
				if afk_time[userid]['rounds'] >= int(sv('ac_afk_rounds_kick')) and int(sv('ac_afk_rounds_kick')):
					es.server.queuecmd('kickid %s Auto Kicked for being AFK'%userid)

def unmakeafk(userid):
	p = playerlib.getPlayer(userid)
	afk_time[int(userid)] = {'rounds': 0, 'time': 0}
	afk_data[int(userid)] = {'vector': p.get('viewvector'), 'prim': p.get('primary'), 'sec': p.get('secondary'), 'loc': p.get('location'), 'he': p.get('he'), 'sg': p.get('sg'), 'fb': p.get('fb')}

def stop_camp(userid):
	coords[int(userid)] = {'time': 0, 'location': (0, 0, 0)}

def check_punish(userid):
	time = coords[int(userid)]['time']
	if time > int(sv('ac_camp_time')):
		es.tell(userid, '#multi', '#lightgreen[Anti Camp]: #defaultCamping detected, move around more, nub')
		if int(sv('ac_camper_push')):
			f = int(sv('ac_camper_push'))
			es.setplayerprop(userid, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', '%s,%s,%s'%(random.randint(-f, f), random.randint(-f, f), random.randint(-f, f)))
		if es.getplayerprop(userid, 'CBasePlayer.m_iHealth') > int(sv('ac_camp_damage')):
			if int(sv('ac_camp_damage')):
				es.setplayerprop(userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CBasePlayer.m_iHealth') - int(sv('ac_camp_damage')))
		else:
			es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 0)
			es.server.queuecmd('es_xfire %s !self ignite'%userid)

def camp_loop():
	gamethread.delayedname(5, 'camp_loop', camp_loop)
	range = int(sv('ac_camp_range'))
	for player in playerlib.getUseridList('%s#alive'%('#human,' if int(sv('ac_camping_bots')) else '')):
		if not playerlib.getPlayer(player).get('primary') in str(sv('ac_excluded_camp_weapons')) and not playerlib.getPlayer(player).get('secondary') in str(sv('ac_excluded_camp_weapons')):
			if not player in coords:
				coords[int(userid)] = {'time': 0, 'location': (0, 0, 0)}
			if afk_time[player]['time'] >= int(sv('ac_camp_time')) / 1.5 and not int(sv('ac_afks_affected_by_anticamp')):
				return
			x, y, z = es.getplayerlocation(player)
			x2, y2, z2 = coords[player]['location']
			if abs(x - x2) <= range and abs(y - y2) <= range and abs(z - z2) <= range:
				coords[player]['time'] += 5
			else:
				coords[player]['time'] = max(0, coords[player]['time'] - 45)
			coords[player]['location'] = es.getplayerlocation(player)
			coords[player]['time'] += int(sv('ac_in_spawn_speedup')) if es.getplayerprop(player, 'CCSPlayer.m_bInBuyZone') else 0
			if int(sv('ac_gg_spawn_camp_boost')):
				for spawn in [es.getindexprop(x, 'CBaseEntity.m_vecOrigin').split(',') for x in es.createentitylist('info_player_terrorist').keys() + es.createentitylist('info_player_counterterrorist').keys()]:
					x, y, z = spawn
					range = int(sv('ac_gg_spawn_point_range'))
					if abs(float(x) - x2) <= range and abs(float(y) - y2) <= range and abs(float(z) - z2) <= range:
						coords[player]['time'] += int(sv('ac_gg_spawn_camp_boost'))
						break
			check_punish(player)

def afk_check_changed():
	gamethread.delayedname(1, 'afk_loop', afk_check_changed)
	for userid in es.getUseridList():
		if not es.getplayersteamid(userid) == 'BOT' and not es.getplayersteamid(userid) in str(sv('ac_immune_afk')).replace(' ', ''):
			p = playerlib.getPlayer(userid)
			if not userid in afk_data:
				afk_data[userid] = {'vector': p.get('viewvector'), 'prim': p.get('primary'), 'sec': p.get('secondary'), 'loc': p.get('location'), 'he': p.get('he'), 'sg': p.get('sg'), 'fb': p.get('fb')}
				continue
			if {'vector': p.get('viewvector'), 'prim': p.get('primary'), 'sec': p.get('secondary'), 'loc': p.get('location'), 'he': p.get('he'), 'sg': p.get('sg'), 'fb': p.get('fb')} == afk_data[userid]:
				if not userid in afk_time:
					afk_time[userid] = {'rounds': 0, 'time': 0}
				afk_time[userid]['time'] += 1
				if afk_time[userid]['time'] >= int(sv('ac_afk_kick_time')) * 60 and int(sv('ac_afk_kick_time')):
					es.server.queuecmd('kickid %s Auto Kicked for being AFK'%userid)
				continue
			afk_time[userid] = {'rounds': 0, 'time': 0}
			afk_data[userid] = {'vector': p.get('viewvector'), 'prim': p.get('primary'), 'sec': p.get('secondary'), 'loc': p.get('location'), 'he': p.get('he'), 'sg': p.get('sg'), 'fb': p.get('fb')}
